Index: trunk/SophyaPI/PI/pi3ddrw.cc
===================================================================
--- trunk/SophyaPI/PI/pi3ddrw.cc	(revision 157)
+++ trunk/SophyaPI/PI/pi3ddrw.cc	(revision 158)
@@ -92,7 +92,12 @@
 PIDraw3DWdg::PIDraw3DWdg(PIContainerGen *par, char *nom, int sx, int sy, int px, int py)
         : PIBaseWdg(par, nom, sx, sy, px, py)
-{
+{  
   vfixed = false;
+//  SetDefaultDrawRectangle(0.12, 0.12, 0.88, 0.88, true);
   SetDefaultDrawRectangle(0., 0., 1., 1., true);
+  mBDrw = new PIElDrawer;
+  mBDrw->SetLimits(0.12,0.88, 0.12,0.88, kAxeDirLtoR,kAxeDirDownUp);
+  AddDrawer(mBDrw, 0.12, 0.12, 0.88, 0.88, true, false, false);
+  mPx = mPy = 0;
 
   lPx = lPy = 0;
@@ -100,4 +105,5 @@
   cTeta = cPhi = 0.;  cUlen = 1.;
 
+  ActivateKeyboard();
   ActivateButton(2);    //  Pour pouvoir tourner la camera
   ActivateMove(2);      
@@ -112,4 +118,5 @@
 PIDraw3DWdg::~PIDraw3DWdg()
 {
+  delete mBDrw;
   delete mGr3d;
 }
@@ -171,4 +178,5 @@
   else Set3DView(xc, yc, zc, xo, yo, zo, dax, day, dco, psi);
   Refresh();
+  mBDrw->Refresh();  // ? Pour reecrire par-dessus ce qui a ete efface 
 }
 
@@ -236,4 +244,29 @@
 
 /* --Methode-- */
+void PIDraw3DWdg::Keyboard(int key, PIKeyModifier kmod)
+{
+if (kmod == PIKM_Alt) {
+  if (key == 'V' || key == 'v') RequestSelection();  // Pour coller (copier/coller)  
+  if (key == 'Z' || key == 'z') { mBDrw->ElDelAll();  Refresh(); } // Pour supprimer tous les signes 
+  if (key == 'O' || key == 'o') { 
+    PIDrwTools::SetCurrentBaseWdg(this);
+    PIDrwTools::ShowPIDrwTools();   // Fentre axes et options de trace
+    }
+  }
+}
+/* --Methode-- */
+void PIDraw3DWdg::PasteSelection(unsigned int typ, void *pdata, unsigned int l)
+{
+if (typ != PICP_string) return;
+int ll = (l<256) ? l+1 : 256;
+char pc[256];
+strncpy(pc, (char*)pdata, ll-1);  pc[ll-1] = '\0';
+// printf("PIDraw3DWdg::PasteSelection() / Debug  %s - %d %d -> %g %g \n", pc, 
+//        mPx, mPy, (float)mPx/(float)XSize(), 1.-(float)mPy/(float)YSize());
+mBDrw->ElAddText((float)mPx/(float)XSize(), 1.-(float)mPy/(float)YSize(), pc );
+mBDrw->Refresh();
+}
+
+/* --Methode-- */
 void PIDraw3DWdg::But2Press(int x, int y)
 {
@@ -247,13 +280,19 @@
   lPx = x;  lPy = y;
 
-// Pour savoir si on se trouve ds la zone centrale     
+// Pour savoir si on se trouve ds la zone centrale   
   int czx = XSize()/10;
   int czy = YSize()/10;
-  int dmix = x-XSize()/2;
-  int dmiy = y-YSize()/2;
-  if (dmix < 0) dmix = -dmix;
-  if (dmiy < 0) dmiy = -dmiy;
-  if ((dmix < czx) && (dmiy < czy))  rOfg = true;
-  else rOfg = false;
+  PIKeyModifier kmod;
+  unsigned long tm;
+  GetLastEventInfo(kmod, tm);
+  rOfg = false;
+  if (kmod ==  PIKM_Shift)  rOfg = true;
+  else {
+    int dmix = x-XSize()/2;
+    int dmiy = y-YSize()/2;
+    if (dmix < 0) dmix = -dmix;
+    if (dmiy < 0) dmiy = -dmiy;
+    if ((dmix < czx) && (dmiy < czy))  rOfg = true;
+    }
 
   cUlen = 0.5*(dax+day)*co*0.3;    cDax = dax;   cDay = day;  clCO = co; 
@@ -319,4 +358,5 @@
   SetDrawers3DView();
   Refresh();
+  mBDrw->Refresh();
 }
 
@@ -382,4 +422,5 @@
   SetDrawers3DView();
   Refresh();
+  mBDrw->Refresh();
 }
 
@@ -421,4 +462,5 @@
   Send(Msg(), PIMsg_Active);
   PIDrwTools::SetCurrentBaseWdg(this);
+  mPx = x;  mPy = y;
   if ( (x > 50) || ( y > 50) ) return; 
   Update3DView();
Index: trunk/SophyaPI/PI/pi3ddrw.h
===================================================================
--- trunk/SophyaPI/PI/pi3ddrw.h	(revision 157)
+++ trunk/SophyaPI/PI/pi3ddrw.h	(revision 158)
@@ -1,2 +1,3 @@
+// This may look like C code, but it is really -*- C++ -*-
 // Module PI : Peida Interactive PIDrawer3D PIDraw3DWdg
 // Drawer et DrawWidget 3D       R. Ansari 06/98
@@ -14,5 +15,6 @@
 #include <list>
 
-// Traceur (Drawer) 3D 
+// -----------------  Traceur (Drawer) 3D  -------------------
+
 class PIDrawer3D : public PIDrawer
 {
@@ -40,4 +42,5 @@
 
 
+//------------------------------ Classe PIDrawer3D --------------------
 
 class PIDraw3DWdg : public PIBaseWdg {
@@ -50,4 +53,5 @@
   virtual long		kind() {return ClassId; }
 
+
   virtual void		Set3DView_Obs(float xo, float yo, float zo, float teta, float phi, float psi, 
                                       float dax, float day, float co, float dco=0.2);
@@ -58,4 +62,9 @@
 
   virtual void          Update3DView();   // Vue 3-D a partir de Drawer No 1
+
+  inline void	     	SetTitles(const char* tt=NULL, const char* tb=NULL)
+                                  { mBDrw->SetTitles(tt, tb); }
+  inline void	     	SetTitles(string const & tt, string const & tb)
+                                  { mBDrw->SetTitles(tt, tb); }
 
   int                   AddDrawer3D(PIDrawer3D*, bool ad=false);   // Ajoute un Drawer 
@@ -75,4 +84,7 @@
   virtual void		Ptr3Move(int x, int y);
 
+  virtual void 		Keyboard(int key, PIKeyModifier kmod);
+  virtual void 		PasteSelection(unsigned int typ, void *pdata, unsigned int l);
+
 
 protected :
@@ -80,4 +92,7 @@
   virtual void		DrawXYZAxes();
 
+  PIElDrawer* mBDrw;   // Objet traceur d'elements de fond
+  int mPx, mPy;        // Position pointeur - Bouton-1 
+  
   bool vfixed;       // SetView fait ou pas
   list<int> m3DrIl;  // Liste des Id drawers 3D 
Index: trunk/SophyaPI/PI/pibwdggen.cc
===================================================================
--- trunk/SophyaPI/PI/pibwdggen.cc	(revision 157)
+++ trunk/SophyaPI/PI/pibwdggen.cc	(revision 158)
@@ -1,2 +1,6 @@
+// Module PI : Peida Interactive     PIBaseWdg
+// Classe de base pour nouvelles composantes graphiques  96
+// LAL (Orsay) / IN2P3-CNRS  DAPNIA/SPP (Saclay) / CEA
+
 #include <stdio.h>
 
@@ -6,5 +10,84 @@
 #include "pidrwtools.h"
 
-// Les methodes de la classe  PIBWdgGen
+
+//++
+// Class	PIBaseWdg
+// Lib		PI
+// include	pibwdggen.h
+//
+//   	Classe de base pour la création de nouvelles composantes graphiques.
+//	Le traitement des événements liés à l'écran, clavier, souris se fait
+//	à travers des méthodes de cette classe : "Resize()", "But1Press()", ...
+//	La classe "PIBaseWdg" supporte en outre un mécanisme permettant
+//	d'associer un ou plusieurs objets traceur (*Drawer*) capables 
+//	de se dessiner dans la fenêtre associée à l'objet.
+//	La classe "PIBaseWdgGen" définit l'interface et ne peut pas être instanciée 
+//	directement (Méthodes virtuelles pures). Les objets instanciés sont de la 
+//	classe "PIBaseWdg" et le fichier entête correspondant est "PIBWDG_H"
+//	défini dans "pisysdep.h".
+//--
+//++
+// Links	Parents
+// PIWdg
+//--
+//++
+// Links	Voir aussi
+// PIGraphic
+// PIDrawer
+//--
+
+// ---------- Les methodes de la classe  PIBWdgGen ------------
+
+//++
+// Titre	Constructeur
+//--
+//++
+//  PIBaseWdgGen(PIContainerGen *par, char *nom, int sx=10, int sy=10, int px=0, int py=0)
+//	Création d'un objet contenu dans l'objet *PIContainer* "par", de
+//	taille "sx,sy", se trouvant à la position "px,py" avec le nom "nom"	
+//--
+
+//++
+// Titre	Méthodes
+//--
+//++
+// void  SetBackgroundColor(PIColors col=PI_White)
+//	Choix de la couleur de fond.
+// void  EraseWindow(int x0=0, int y0=0, int dx=0, int dy=0) 
+//	Efface la zone rectangulaire définie par le coin "(x0,y0)" ,
+//	de taille "dx,dy" à l'aide de la couleur de fond.
+// void  SelPointerShape(PIPointer ptr=PI_ArrowPointer) 
+//	Choix de la forme du pointeur (souris) pour la fenêtre 
+//	associée à l'objet.
+//|	PI_ArrowPointer, PI_CrossPointer, PI_HandPointer, PI_TDLRArrowPointer
+// PIColors  GetBackgroundColor()
+//	Renvoie la couleur de fond
+// PIPointer  GetPointerShape() 
+//	Renvoie la forme du pointeur
+// void  Refresh()
+//	L'appel à cette méthode permet de retracer le contenu de la 
+//	fenêtre et des "Drawer" associés.
+//--
+
+//++
+// Titre	Activation du traitement des événements
+//--
+//++
+// void  ActivatePtrCross()
+//	Active l'appel aux méthodes "Enter()" et "Leave()" lorsque la souris
+//	rentre ou sort de la fenêtre correspondante à l'objet
+// void  ActivateButton(int b)
+//	Active l'appel aux méthodes "ButbPress()" et "ButxRelease()" pour
+//	le bouton "b" de la souris ("b=1,2,3")
+// void  ActivateMove(int b) 
+//	Active l'appel aux méthodes "PtrbMove()" lors des mouvements de
+//	la souris avec le bouton "b" enfoncé ("b=1,2,3")
+//	L'appel avec "bid=0" active l'appel à la méthode "PtrMove()"
+//	Lors des mouvements de souris sans bouton enfoncé.
+// void  ActivateKeyboard()
+//	Active l'appel à la méthode "Keyboard()" lors de l'appui sur les 
+//	touches du clavier.
+//--
+
  
 /* --Methode-- */
@@ -42,4 +125,51 @@
 
 
+//++
+// Titre	Gestion des événements
+//--
+//++
+// void  Draw(PIGraphic* g, int x0, int y0, int dx, int dy)
+//	Méthode appelée lorsqu'il faut redessiner tout ou partie de
+//	la fenêtre. La zone a rafraîchir est determinée par 
+//	"(x0,y0)", "dx,dy" et "g" est l'objet "PIGraphic" 
+//	qui doit être utilisé.
+//	Cette méthode ne doit pas être appelé directement. 
+//	Pour rafraîchir le contenu de la fenêtre, il faut appeler
+//	la méthode "Refresh()"
+// void  Resize()
+//	Méthode appelée lorsque la taille de l'objet est modifiée.
+//	"XSize()", "YSize()" fournissent la nouvelle taille de l'objet.
+// void  Enter()
+//	Méthode appelée lorsque le pointeur rentre dans la fenêtre
+//	(Si "ActivatePtrCross()" a été appelé )
+// void  Leave()
+//	Méthode appelée lorsque le pointeur quitte la fenêtre
+//	(Si "ActivatePtrCross()" a été appelé )
+// void  ButbPress(int x, int y)  (b=1,2,3)
+//	Méthode appelée lorsque le bouton "b=1,2,3" de la souris est enfoncé.
+//	"x,y" : Position de la souris
+//	(Si "ActivateButton(b)" a été appelé )
+// void  ButbRelease(int x, int y)   (b=1,2,3)
+//	Méthode appelée lorsque le bouton "b=1,2,3" de la souris est relaché.
+//	"x,y" : Position de la souris
+//	(Si "ActivateButton(b)" a été appelé )
+// void  PtrMove(int x, int y)
+//	Méthode appelée lors des mouvements de la souris. "x,y" : Position de la souris
+//	(Si "ActivateMove(0)" a été appelé )
+// void  PtrbMove(int x, int y)     (b=1,2,3)
+//	Méthode appelée lors des mouvements de la souris, avec le 
+//	bouton "b=1,2,3" appuyé. "x,y" : Position de la souris
+//	(Si "ActivateMove(b)" a été appelé )
+// void  Keyboard(int key, PIKeyModifier kmod)
+//	Méthode appelée en réponse à des actions sur le clavier.
+//	"key" est le code ASCII de la touche enfoncé - "kmod" indique
+//	si des touches speciaux étaient enfoncés en même temps.
+//|	kmod =  PIKM_Blank |  PIKM_Shift | PIKM_Alt | PIKM_Cntl
+//	Des constantes ont été définis pour certaines touches particulières
+//|	PIK_Return , PIK_Enter , PIK_BackSpace, PIK_Delete
+//|	PIK_Tab , PIK_Escape , PIK_Up , PIK_Down, 
+//|	PIK_Right , PIK_Left , PIK_Previous , PIK_Next
+//--
+
 /* --Methode-- */
 void PIBaseWdgGen::Draw(PIGraphic* g, int x0, int y0, int dx, int dy)
@@ -124,4 +254,12 @@
 }
 
+/* --Methode-- */
+void PIBaseWdgGen::PtrMove(int /*x*/, int /*y*/)
+{
+#ifdef DEBUG_RZXB
+printf ("Debug_PIBaseWdgGen::PtrMove PosX,Y= %d %d \n", x, y);
+#endif
+return;
+}
 
 /* --Methode-- */
@@ -167,4 +305,21 @@
 }
 
+//++
+// Titre	Gestion des traceurs (PIDrawer)
+//	Un même "PIDrawer" peut être attaché simultanement à plusieurs "PIBaseWdg", ainsi
+//	que plusieurs fois au même "PIBaseWdg", avec des identificateurs différents.
+//--
+//++
+// void  SetDefaultDrawRectangle(PIGrCoord x1, PIGrCoord y1, PIGrCoord x2, PIGrCoord y2, bool psz=true)
+//	Définition du rectangle d'attachement par défaut. "(x1,y1)" et "(x2,y2)" determinent
+//	les positions des deux coins opposés.
+//	si "psz=true", les coordonnées sont supposées être des facteurs multiplicatifs 
+//	des dimensions de l'objet.
+// void  SetDefaultDrawerLimits(float xmin, float xmax, float ymin, float ymax, -
+//                              int axrl=kAxeDirSame, int ayud=kAxeDirSame)
+//	Définition du système de coordonnées par défaut d'un drawer attaché en "autolim=true"
+//
+//--
+
 /* --Methode-- */
 void PIBaseWdgGen::SetDefaultDrawRectangle(PIGrCoord x1, PIGrCoord y1, PIGrCoord x2, PIGrCoord y2, bool psz)
@@ -183,4 +338,24 @@
 }
 
+
+//++
+// int  AddDrawer(PIDrawer* drw, PIGrCoord x1, PIGrCoord y1, PIGrCoord x2, PIGrCoord y2, -
+//                bool psz=true, bool clip=true, bool ad=false)
+//	Attachement d'un "PIDrawer" au rectangle défini les coordonnées des deux coins opposés.
+//	si "psz=true", les coordonnées sont supposées être des facteurs multiplicatifs 
+//	des dimensions de l'objet.
+//	si "clip=true", "PIDrawer* drw" ne peut dessiner en dehors de son rectangle
+//	d'attachement.
+//	si "ad=true", le "PIDrawer* drw" est détruit lors de la destruction de l'objet PIBaseWdg.
+//	La méthode retourne l'identificateur du drawer attaché.
+// int  AddDrawer(PIDrawer* drw, bool autolim=false, bool clip=true, bool ad=false)
+//	Ajout d'un "PIDrawer" au rectangle d'attachement par défaut. 
+//	Si "autolim=true", l'objet "PIBaseWdg" impose l'espace de coordonnées utilisateur
+//	à l'aide des valeurs définies par "SetDefaultDrawerLimits()".
+//	Si ""clip=true", "PIDrawer* drw" ne peut dessiner en dehors de son rectangle 
+//	d'attachement.
+//	si "ad=true", le "PIDrawer* drw" est détruit lors de la destruction de l'objet PIBaseWdg.
+//	La méthode retourne l'identificateur du drawer attaché.
+//--
 
 /* --Methode-- */
@@ -220,4 +395,14 @@
 
 
+//++
+// void  MoveResizeDrawer(int id, PIGrCoord x1, PIGrCoord y1, PIGrCoord x2, PIGrCoord y2, bool psz=true)
+//	Modification du rectangle d'attachement du PIDrawer avec l'identificateur "id" , retourné
+//	par "AddDrawer()"
+// void  RemoveDrawer(int id)
+//	Ote le drawer "id" de la liste
+// void  DeleteDrawers()
+//	Ote tous les drawers de la liste. Détruit ceux ajoutés avec l'option "ad=true" 
+//--
+
 /* --Methode-- */
 void PIBaseWdgGen::MoveResizeDrawer(int id,  PIGrCoord x1, PIGrCoord y1,  PIGrCoord x2, PIGrCoord y2, bool psz)
@@ -257,4 +442,13 @@
 }
 
+//++
+// int  NbDrawers()
+//	Retourne le nombre de PIDrawer attachés
+// PIDrawer*  GetDrawerId(int id)
+//	Retourne le PIDrawer avec l'identificateur id
+// PIDrawer*  GetDrawer(int n)
+//	Retourne le PIDrawer "n=0..NbDrawers()-1" de la liste
+//--
+
 /* --Methode-- */
 int PIBaseWdgGen::NbDrawers()
@@ -280,4 +474,11 @@
 }
 
+
+//++
+// void  CallDrawers(PIGraphic* g, int x0=0, int y0=0, int dx=0, int dy=0)
+//	Appel de la méthode de tracé pour tous les Drawers
+// void  CallDrawer(int id);
+//	Appel de la méthode de tracé pour le drawer avec l'identificateur "id"
+//--
 
 /* --Methode-- */
Index: trunk/SophyaPI/PI/pibwdggen.h
===================================================================
--- trunk/SophyaPI/PI/pibwdggen.h	(revision 157)
+++ trunk/SophyaPI/PI/pibwdggen.h	(revision 158)
@@ -15,10 +15,10 @@
 enum PIKeyModifier { PIKM_Blank = 0, PIKM_Shift = 1, PIKM_Alt = 2, PIKM_Cntl = 4 } ; 
 
-enum PIKeyValues { PIK_Return = 1+0x2000, PIK_Enter = 2+0x2000 , 
-                   PIK_BackSpace = 3+0x2000, PIK_Delete = 4+0x2000,
-                   PIK_Tab = 5+0x2000, PIK_Escape = 6+0x2000, 
-                   PIK_Up = 11+0x2000, PIK_Down = 12+0x2000, 
-                   PIK_Right = 13+0x2000, PIK_Left = 14+0x2000,
-                   PIK_Previous = 21+0x2000, PIK_Next = 22+0x2000  } ; 
+enum PIKeyValues { PIK_Return = 0xFF0D, PIK_Enter = 0xFF8D , 
+                   PIK_BackSpace = 0xFF08, PIK_Delete = 0xFFFF,
+                   PIK_Tab = 0xFF09, PIK_Escape = 0xFF1B, 
+                   PIK_Up = 0xFF52, PIK_Down = 0xFF54, 
+                   PIK_Right = 0xFF53, PIK_Left = 0xFF51,
+                   PIK_Previous = 0xFF55, PIK_Next = 0xFF56  } ; 
 
 
@@ -70,8 +70,12 @@
   virtual void       But3Press(int x, int y);
   virtual void       But3Release(int x, int y);
+  virtual void       PtrMove(int x, int y);
   virtual void       Ptr1Move(int x, int y);
   virtual void       Ptr2Move(int x, int y);
   virtual void       Ptr3Move(int x, int y);
   virtual void       Keyboard(int key, PIKeyModifier kmod);
+
+// Acces aux caracteristiques du dernier evenement 
+  virtual void       GetLastEventInfo(PIKeyModifier& kmod, unsigned long& tm) = 0;
 
 // PostScript output
Index: trunk/SophyaPI/PI/pibwdgx.cc
===================================================================
--- trunk/SophyaPI/PI/pibwdgx.cc	(revision 157)
+++ trunk/SophyaPI/PI/pibwdgx.cc	(revision 158)
@@ -1,2 +1,7 @@
+// This may look like C code, but it is really -*- C++ -*-
+// Module PI : Peida Interactive      PIBaseWdg
+//                                    Reza 95-96
+// LAL (Orsay) / IN2P3-CNRS  DAPNIA/SPP (Saclay) / CEA
+
 #include <stdio.h>
 
@@ -29,4 +34,6 @@
 
 Init();
+mWGrC = NULL; // PIGraphic (Contexte graphique) associe a la fenetre
+finishDone = false;     // FinishCreate() pas encore appele
 
 CreateXtWdg(nom, piXtBaseWidgetClass, NULL, sx, sy, px, py);
@@ -42,7 +49,8 @@
 mPtrS = PI_CrossPointer;
 SelPointerShape();
-
+// PIGraphic (Contexte graphique) associe a la fenetre
+// Si pas cree par FinishCreate()
+if (!mWGrC) mWGrC = new PIGraphicX(this);   
 Manage();
-mWGrC = new PIGraphicX(this);   // PIGraphic (Contexte graphique) associe a la fenetre
 }
 
@@ -63,4 +71,8 @@
 void PIBaseWdgX::FinishCreate()
 {
+if (finishDone) { 
+  fprintf(stderr, "BUG/PIBaseWdgX::FinishCreate() multiple call \n"); 
+  return; 
+  }
 // appele par la fenetre mere, apres XtRealize()
 // J'active le backing store pour la fenetre X
@@ -80,5 +92,16 @@
 // XChangeWindowAttributes(PIXDisplay(), XtWindow(XtWdg()), CWBackingPlanes|CWBackingStore, &xswa);
 XChangeWindowAttributes(PIXDisplay(), mwi, CWBackingStore, &xswa);
+
+// PIGraphic (Contexte graphique) associe a la fenetre
+if (!mWGrC) mWGrC = new PIGraphicX(this);   
+mWGrC->TerminateInit();
+finishDone = true;     // FinishCreate() fait
 } 
+
+/* --Methode-- */
+bool PIBaseWdgX::IsVisible()
+{
+return (finishDone && PIWdg::IsVisible() ); 
+}
 
 /* --Methode-- */
@@ -114,6 +137,9 @@
 unsigned long evtmask ;
 
-if ( (bid < 1) && (bid > 3) ) return; 
-if (bid == 1)  evtmask = Button1MotionMask | PointerMotionHintMask ;
+// bid == 0  -> PointerMove sans bouton 
+if ( (bid < 0) && (bid > 3) ) return; 
+
+if (bid == 0) evtmask = PointerMotionHintMask ;
+else if (bid == 1) evtmask = Button1MotionMask | PointerMotionHintMask ;
 else if (bid == 2) evtmask = Button2MotionMask | PointerMotionHintMask ;
 else if (bid == 3) evtmask = Button3MotionMask | PointerMotionHintMask ;
@@ -177,4 +203,17 @@
 }
 
+/* --Methode-- */
+void PIBaseWdgX::GetLastEventInfo(PIKeyModifier& kmod, unsigned long& tm)
+{
+unsigned int st;
+Time t;
+PIXGetLastEventInfo(st, t);
+tm = t;
+kmod = PIKM_Blank;
+if  (st & ShiftMask)   kmod = (PIKeyModifier) (kmod | PIKM_Shift);
+if  (st & ControlMask) kmod = (PIKeyModifier) (kmod | PIKM_Cntl);
+if  (st & Mod1Mask)    kmod = (PIKeyModifier) (kmod | PIKM_Alt);
+return;
+}
 
 static bool fgbwdg = false ;
Index: trunk/SophyaPI/PI/pibwdgx.h
===================================================================
--- trunk/SophyaPI/PI/pibwdgx.h	(revision 157)
+++ trunk/SophyaPI/PI/pibwdgx.h	(revision 158)
@@ -1,2 +1,7 @@
+// This may look like C code, but it is really -*- C++ -*-
+// Module PI : Peida Interactive      PIBaseWdg
+//                                    Reza  95-96
+// LAL (Orsay) / IN2P3-CNRS  DAPNIA/SPP (Saclay) / CEA
+
 #ifndef PIBWDGX_H_SEEN
 #define PIBWDGX_H_SEEN
@@ -6,4 +11,5 @@
 
 #include "pigraphx.h"
+            
 #include "pigraphps.h"
 
@@ -34,4 +40,10 @@
   virtual void       AssignKeyboard();
 
+// Acces aux caracteristiques du dernier evenement 
+  virtual void       GetLastEventInfo(PIKeyModifier& kmod, unsigned long& tm);
+
+// On redefinit IsVisible() pour tenir compte de l appel a FinsihCreate  
+  virtual bool       IsVisible();
+
 //  Appel depuis le PIXtBaseWidget uniquement (ExposeEvt de Xt )
   virtual void       eXposeProcess(int x0, int y0, int dx, int dy);
@@ -41,4 +53,5 @@
   PIPointer mPtrS;
   PIColors mBCol;
+  bool finishDone;       // Si FinsihCreate appele
 };
 
Index: trunk/SophyaPI/PI/picons.cc
===================================================================
--- trunk/SophyaPI/PI/picons.cc	(revision 157)
+++ trunk/SophyaPI/PI/picons.cc	(revision 158)
@@ -586,5 +586,6 @@
 int x,y;
 
-// printf("PIConsole::DisplayLines(%d %d ) \n ", l1, l2);
+// DBG printf("PIConsole::DisplayLines(%d %d ) -> %d - %lx \n ", l1, l2, 
+//            (int)IsVisible(), (long)XtWindow(XtWdg()));
 
 if (! IsVisible() )   return;
Index: trunk/SophyaPI/PI/picontainergen.cc
===================================================================
--- trunk/SophyaPI/PI/picontainergen.cc	(revision 157)
+++ trunk/SophyaPI/PI/picontainergen.cc	(revision 158)
@@ -4,4 +4,6 @@
 //                  E.Aubourg , R. Ansari  96 - 98
 // LAL (Orsay) / IN2P3-CNRS  DAPNIA/SPP (Saclay) / CEA
+
+#include <stdio.h>
 
 #include "picontainergen.h"
@@ -15,5 +17,10 @@
 //	organise la hiérarchie des objets "PIWdg" et donc aussi des "PIMsgHandler",
 //	contrôle la géométrie des objets "PIWdg" contenus, ainsi que leur 
-//	visibilité et activité. La classe "PIContainer" est une des 
+//	visibilité et activité. Le positionnement initial est controle par
+//	un objet *PILayoutMgr* qui peut eventuellement modifier la postion
+//	ou la taille de l'objet "PIWdg" ajouté. Les attributs d'attachement
+//	de l'objet ("PIWdg::SetBinding()") contrôle le repositionnement
+//	lors du changement de taille du "PIContainer".
+//	La classe "PIContainer" est une des 
 //	classes de PI qui ont une implementation dépendante du systeme utilisé
 //	(Mac, XWindow, ...). La classe "PIContainerGen" est la classe qui
@@ -26,4 +33,8 @@
 // Links	Parents
 // PIWdg
+//--
+//++
+// Links	Voir aussi
+// PILayoutMgr
 //--
 //++
@@ -43,4 +54,13 @@
 //--
 //++
+// void SetLayoutMgr(PILayoutMgr* nlay)
+//	Permet de changer le gestionnaire de positions ("PILayoutMgr") du conteneur,
+//	et donc la stratégie de positionnement des objets "PIWdg" fils. 
+//	le LayoutMgr par défaut n'applique aucune contrainte sur la position
+//	ou la taille des objets ajoutés.
+//	Cette méthode ne peut être appelé que pour un conteneur vide (sans PIWdg fils).
+//	Il est conseillé de l'appeler juste après la création du "PIContainer"
+// PILayoutMgr* GetLayoutMgr()
+//	Retourne le gestionnaire de positions/tailles du conteneur.
 // void Show()
 //	Rend l'objet visible à l'écran. Tous les objets "PIWdg" contenus et qui sont dans 
@@ -50,11 +70,26 @@
 // void  PSPrint(PSFile *psf, int ofx=0, int ofy=0)
 //	Appelle la méthode "PSPrint()" pour tous les objets contenus.
-// void  SetAutoDelChilds(bool ad = false)
+// void  SetAutoDelChilds(bool ad = true)
 //	Contrôle le comportement de l'objet conteneur vis à vis des objets
 //	contenus lors de la destruction. si "ad=true", les objets contenus 
 //	sont détruits lors de l'appel du destructeur de l'objet conteneur. 
-//--
-
-#define NCHALGRP 8
+// int  NbChilds()
+//	Retourne le nombre de "PIWdg" contenus.
+// PIWdg* GetChild(int n)
+//	Retourne le "PIWdg" numéro "n" (0..NbChilds()-1) 
+//--
+//++
+// Titre 	Méthodes particulières
+//	Les méthodes ci-dessous ne doivent pas être appelées directement.
+//--
+//++
+// void ChildAdd(PIWdg* child)
+//	Méthode qui est appelée lors de l'attachement d'un nouvel objet (création)
+//	Appelle la méthode correspondante du "PILayoutMgr"
+// void ChildAdd(PIWdg* child)
+//	Méthode qui est appelée lors du détachement d'un objet (destruction)
+//	Appelle la méthode correspondante du "PILayoutMgr"	
+//--
+
 
 /* --Methode-- */
@@ -63,16 +98,156 @@
 : PIWdg(par, nom, sx, sy, px, py)  
 {
+stvis = false;
+stfcr = false;
+layout = new PILayoutMgr;
+layout->SetContainer(this); 
+}
+
+
+/* --Methode-- */
+PIContainerGen::~PIContainerGen()
+{
+delete layout;
+}
+
+/* --Methode-- */
+void PIContainerGen::SetLayoutMgr(PILayoutMgr* nlay)
+{
+if (nlay == NULL) return;
+if (NbChilds() > 0) {
+  fprintf(stderr, "PIContainerGen::SetLayoutMgr()/ Error! Container has childs (N = %d) \n", NbChilds()); 
+  return;
+  }
+delete layout;
+layout = nlay;
+layout->SetContainer(this); 
+}
+
+/* --Methode-- */
+void PIContainerGen::PSPrint(PSFile *psf, int ofx, int ofy)
+{
+int i;
+if (!psf)  return;
+if (!Visible())  return;
+for(i=0; i<NbChilds(); i++)  GetChild(i)->PSPrint(psf, ofx+XPos(), ofy+YPos()); 
+return;
+}
+
+/* --Methode-- */
+void PIContainerGen::Show()
+{
+stvis = true;
+Manage();
+return;
+}
+
+/* --Methode-- */
+void PIContainerGen::Hide()
+{
+stvis = false;
+UnManage();
+return;
+}
+
+/* --Methode-- */
+bool PIContainerGen::Visible()
+{
+if (Parent())  return(stvis && Parent()->Visible());
+else return(stvis && IsVisible());
+}
+
+/* --Methode-- */
+void PIContainerGen::ChildAdd(PIWdg* child)
+{
+layout->ChildAdd(child);
+// Reza 13/10/98 : il faut que child->FinishCreate() 
+// soit appele pour les PIWdg ajoute quand le  container est deja affiche et son FinishCreate() appele
+if (stfcr)  child->FinishCreate(); 
+return;
+}
+
+/* --Methode-- */
+void PIContainerGen::ChildDel(PIWdg* child)
+{
+layout->ChildDel(child);
+}
+
+/* --Methode-- */
+int PIContainerGen::NbChilds()
+{
+return(layout->NbChilds());
+}
+
+/* --Methode-- */
+PIWdg* PIContainerGen::GetChild(int n)
+{
+return(layout->GetChild(n));
+}
+
+/* --Methode-- */
+void PIContainerGen::SetAutoDelChilds(bool ad)
+{
+layout->SetAutoDelChilds(ad) ;
+}
+
+
+/* --Methode-- */
+void PIContainerGen::FinishCreate()
+{
+if (stfcr)  return;
+int k;
+for(k=0; k<NbChilds(); k++)  GetChild(k)->FinishCreate();
+stfcr = true;
+}
+
+
+// ------------------------------------------------------------------
+//  Classe PILayoutMgr (Gestionnaire de positions/tailles PIWdg fils
+// ------------------------------------------------------------------
+//++
+// Class	PILayoutMgr
+// Lib		PI
+// include	picontainergen.h
+//
+//	Classe de gestionnaire de positions/tailles initiales des "PIWdg"
+//	fils pour les "PIContainer".
+//	La classe de base n'impose aucune contrainte sur les positions/tailles.
+//--
+//++
+// Links	Voir
+// PIContainer
+//--
+
+//++
+// Titre	Constructeur, méthodes
+//--
+//++
+// PILayoutMgr()
+//	Constructeur
+// void ChildAdd(PIWdg* child)
+//	Méthode appelé lors de l'ajout d'un nouveau "PIWdg" au conteneur.
+// void ChildDel(PIWdg* child)
+//	Méthode appelé lors de la suppression d'un "PIWdg"
+// int  NbChilds() 
+//	Nombre de "PIWdg" gérés.
+// PIWdg* GetChild(int n)
+//	Retourne l'objet "PIWdg" numéro "n"
+//--
+
+#define NCHALGRP 8
+
+/* --Methode-- */
+PILayoutMgr::PILayoutMgr()
+{
 mNCh = 0;
-mACSup = false;   // Suppression automatique des widgets fils au delete
+mACSup = true;   // Suppression automatique des widgets fils au delete
 mPaSup = false;
 mChilds = new (PIWdg* [NCHALGRP]);
 mMxCh = NCHALGRP;
-stvis = false;
-stfcr = false;
-}
-
-
-/* --Methode-- */
-PIContainerGen::~PIContainerGen()
+mCont = NULL;
+}
+
+/* --Methode-- */
+PILayoutMgr::~PILayoutMgr()
 {
 mPaSup = true;   // Pour prevenir ChildDel()
@@ -83,38 +258,5 @@
 
 /* --Methode-- */
-void PIContainerGen::PSPrint(PSFile *psf, int ofx, int ofy)
-{
-int i;
-if (!psf)  return;
-if (!Visible())  return;
-for(i=0; i<mNCh; i++)  mChilds[i]->PSPrint(psf, ofx+XPos(), ofy+YPos()); 
-return;
-}
-
-/* --Methode-- */
-void PIContainerGen::Show()
-{
-stvis = true;
-Manage();
-return;
-}
-
-/* --Methode-- */
-void PIContainerGen::Hide()
-{
-stvis = false;
-UnManage();
-return;
-}
-
-/* --Methode-- */
-bool PIContainerGen::Visible()
-{
-if (Parent())  return(stvis && Parent()->Visible());
-else return(stvis && IsVisible());
-}
-
-/* --Methode-- */
-void PIContainerGen::ChildAdd(PIWdg* child)
+void PILayoutMgr::ChildAdd(PIWdg* child)
 {
 if (child == NULL)  return;
@@ -128,14 +270,11 @@
   }  
 mChilds[mNCh] = child;   mNCh++; 
-// Reza 13/10/98 : il faut que child->FinishCreate() 
-// soit appele pour les PIWdg ajoute quand le  container est deja affiche et son FinishCreate() appele
-if (stfcr)  child->FinishCreate(); 
-return;
-}
-
-/* --Methode-- */
-void PIContainerGen::ChildDel(PIWdg* child)
-{
-if (mPaSup) return;  // Ne rien faire si delete initie par Container-parent
+return;
+}
+
+/* --Methode-- */
+void PILayoutMgr::ChildDel(PIWdg* child)
+{
+if (mPaSup) return;  // Ne rien faire si delete initie par Container-parent : Le LayoutMgr lui-meme
 if ((child == NULL) || (mNCh < 1))  return;
 for(int i=0; i<mNCh; i++)  
@@ -149,31 +288,2 @@
 }
 
-/* --Methode-- */
-int PIContainerGen::NbChilds()
-{
-return(mNCh);
-}
-
-/* --Methode-- */
-PIWdg* PIContainerGen::GetChild(int n)
-{
-if ( (n < 0) || (n >= mNCh))  return(NULL);
-return ((PIWdg*)mChilds[n]);
-}
-
-/* --Methode-- */
-void PIContainerGen::SetAutoDelChilds(bool ad)
-{
-mACSup = ad;
-return;
-}
-
-/* --Methode-- */
-void PIContainerGen::FinishCreate()
-{
-if (stfcr)  return;
-int k;
-for(k=0; k<mNCh; k++)  mChilds[k]->FinishCreate();
-stfcr = true;
-}
-
Index: trunk/SophyaPI/PI/picontainergen.h
===================================================================
--- trunk/SophyaPI/PI/picontainergen.h	(revision 157)
+++ trunk/SophyaPI/PI/picontainergen.h	(revision 158)
@@ -1,2 +1,7 @@
+// This may look like C code, but it is really -*- C++ -*-
+// Module PI : Peida Interactive    PIContainerGen
+//                  E.Aubourg , R. Ansari  96 - 98
+// LAL (Orsay) / IN2P3-CNRS  DAPNIA/SPP (Saclay) / CEA
+
 #ifndef PICONTAINERBASE_SEEN
 #define PICONTAINERBASE_SEEN
@@ -6,5 +11,30 @@
 #include PIWDG_H
 
+class PIContainerGen;
+//  Classe gestionnaire du positionnement/tailles des PIWdg d'un PIContainer
+class PILayoutMgr {
+public:
+  			PILayoutMgr();
+  virtual 		~PILayoutMgr();
 
+  inline  void		SetContainer(PIContainerGen* pic) { mCont = pic; }
+
+  virtual void		ChildAdd(PIWdg* child);
+  virtual void		ChildDel(PIWdg* child);
+
+  inline  int		NbChilds() { return(mNCh); }
+  inline  PIWdg*	GetChild(int n) 
+                        { if ( (n < 0) || (n >= mNCh))  return(NULL);
+                        else return (mChilds[n]); }
+  inline  void		SetAutoDelChilds(bool ad = true) { mACSup = ad; } 
+
+protected:
+  PIWdg                ** mChilds;
+  int                  mNCh, mMxCh;
+  bool                 mPaSup, mACSup;
+  PIContainerGen*      mCont;   // Le PIContainer auquel on est attache
+};
+
+// Classe conteneur pour le regroupement hierarchique (Fenetre/MsgHandler) des PIWdg
 class PIContainerGen : public PIWdg 
 {
@@ -18,4 +48,7 @@
   virtual long         kind() {return ClassId; }
 
+  virtual void	       SetLayoutMgr(PILayoutMgr* nlay);
+  inline  PILayoutMgr* GetLayoutMgr() { return(layout); }
+
   virtual void         PSPrint(PSFile *psf, int ofx=0, int ofy=0);
 
@@ -28,13 +61,11 @@
   virtual int          NbChilds();
   virtual PIWdg*       GetChild(int n);
+          void         SetAutoDelChilds(bool ad = true);
 
-          void         SetAutoDelChilds(bool ad = false);
   virtual void	       FinishCreate(); // appelle FinishCreate() pour les descendants 
 
 protected:
   bool                 stvis, stfcr;  // Statut visible ou pas, FinishCreate appele ou pas
-  PIWdg                ** mChilds;
-  int                  mNCh, mMxCh;
-  bool                 mPaSup, mACSup;
+  PILayoutMgr*         layout;        // Gestionnaire de positionnement (/tailles) des PIWdg fils
 };
 
